/************************************************************/
/* Program do migania buk							        */
/* Autor: 												    */
/* 			Maciej Wojtyczka		                        */
/* Kwiecie 2004                                            */
/************************************************************/
#include <avr/io.h>
#include <interrupt.h>
#include <avr/signal.h>

#define tau0 255;	 //staa czasowa timera0
#define vliczt0 255; //staa wpisywana do zewntrznego licznika przerwa od timera
#define vliczt1 20;	 //staa wpisywana do wewntrznego licznika przerwa od timera
	
//********************  zmienne globalne  *******************

unsigned char licznik0,licznik1;	//Licznik wej do przerwania timera0.

/****************************************************************/
/************           TRYBY              **********************/
/*** Podcznie:
*             PA4    PA1
*
*		      PA3
*
*          PA7	       PA0	
*		  PA6	    PA2
*		      PA5
*/
unsigned char tryb,   			//zmienna mwica ktry tryb jest wczony
			   tryb1,			//index tablicy trybu 1
			   tryb2,			//index tablicy trybu 2
			   tryb3; 			//index tablicy trybu 3
			   
unsigned char nos_on = 0;     //mwi czy nos jest zaczony ( wtedy rwne 1 )

//tablica kolejnych stanw diod dla trybu pierwszego 
unsigned char tab1[12] = { 229,197,129,0,18,0,18,0,8,0,8,0 } ;
// 01100101, 00100101, 10000101, 11000001, 11100000, 11100100, itd <=
//tablica kolejnych stanw diod dla trybu drugiego 
unsigned char tab2[10] = { 101,37,133,193,224,228, 224,193,133,37 };
//tablica kolejnych stanw diod dla trybu trzeciego 
unsigned char tab3[14] = { 229,101,37,133,193,224,228,229,228, 224,193,133,37,101 };

/*********************************************************************************/
/*   procedura wytracania czasu stosowana po odczycie klawisza                   */
void czekaj(unsigned long zt) 
{		
	 unsigned char zt1;
	 for(;zt>0;zt--)
	 {
		  for(zt1=255;zt1!=0;zt1--);
	 }
}

/*********************************************************************************/
/*   obsuga przerwania od przepenienia timera0    				             */
SIGNAL (SIG_OVERFLOW0)	 
{
 TCNT0=tau0;           //odwie sta czasowa w TCNT0
 if( --licznik0 == 0 )//sprawd czy zewntrzyny licznik sie wyzerowa 
 {
	 if( --licznik1 == 0 )//sprawd czy wewntrzny licznik sie wyzerowa 
	 {
		 //wykonuje gdy oba liczniki s rwne zero
		 //sprawdza tryb i nr. index tablicy dla danego trybu i 
		 //odpowiednio ustawia linie w porcie A
		 if(tryb == 1 )
		 {
			PORTA = tab1[tryb1];
			tryb1++;
			if(tryb1 > 11 )	
				tryb1 = 0;
		 } 
		 else if( tryb == 2 )
		 {
			 PORTA = tab2[tryb2];
			 tryb2++;
			 if( tryb2 > 9 )
			 tryb2 = 0;
		 }
		 else if( tryb == 3 )
		 {
			 PORTA = tab3[tryb3];
			 tryb3++;
			 if( tryb3 > 13 )
				 tryb3 = 0;
		}
		 //ponowne zapisanie licznika wewntrznego sta 
		 licznik1 = vliczt1;
	 }
	 //zapisanie licznika zewntrznego sta 
	 licznik0 = vliczt0;
 }
}

int main(void)
{
	 //zapisanie licznikw staymi pocztkowymi
	 licznik0=vliczt0;
	 licznik1=vliczt1;

	 DDRA=0xff;	    //port A jako wyjcia
	 PORTA=0x00;	//wczamy diody dla kontroli
 
	 DDRB=0xff;	   //PORTB - te jako wyjcia
	 cbi(DDRB,6);  //PORTB6 - wejcie
	 PORTB=0xFF;	//ustawione na 1 - wtedy PORTB6 to wejcie z pull-upem
 
	//inicjalizacja trybw
	tryb = 1;
	tryb1 = 0;
	tryb2 = 0;
	tryb3 = 0;
	
	czekaj( 1500 );//odczekanie czasu z zapalonymi wszystkimi diodami
	PORTA=0xff;	   //zgaszenie diod
 
	TIMSK=1<<TOIE0;	      //zezwolenie na przerwania od TC0
	TCNT0=tau0;           //wpisz sta czasowa do TCNT0
	TCCR0=1;              //ustaw preskaler na XTAL/1024, 

    sei();                //odblokuj globalne przerwania
  
	unsigned char i; 
	while(1)			  //ptla nieskoczona
	{
  
		i = PINB;		  //zapisz do i warto portu B
	    if( ((i >> 6) & 1) == 0  ) //gdy wejscie PORTB6 jest rwne 0
	    {
			tryb++;					//przejd do nastpnego trybu
		    if( tryb > 3 )			//gdy przekroczona liczba trybw
				tryb = 1;			//to tryb pierwszy
		    czekaj(10L);			//odczekaj czas aby przeczeka drganie stykw przycisku
	    }	 	   
	}
}